package org.obm.push.backend.obm22.mail.smtp;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.columba.ristretto.smtp.SMTPProtocol;
import org.obm.locator.client.LocatorClient;
import org.obm.push.backend.BackendSession;
import org.obm.push.exception.SmtpLocatorException;

public class SmtpLocator {

	private Log logger = LogFactory.getLog(getClass());

	public SmtpLocator() {
	}

	public SMTPProtocol getSmtpClient(BackendSession bs)
			throws SmtpLocatorException {
		String smtpHost = new LocatorClient().locateHost("mail/smtp_out",
				bs.getLoginAtDomain());
		if (smtpHost == null) {
			throw new SmtpLocatorException("Smtp server cannot be discovered");
		}
		logger.info("Using " + smtpHost + " as smtp host.");
		SMTPProtocol proto = new SMTPProtocol(smtpHost);
		return proto;
	}

}
