package org.obm.push.impl;

import java.io.InputStream;

import org.obm.push.backend.BackendSession;
import org.obm.push.backend.IBackend;
import org.obm.push.backend.IContinuation;
import org.obm.push.exception.ProcessingEmailException;
import org.obm.push.exception.SendEmailException;
import org.obm.push.exception.SmtpInvalidRcptException;

/**
 * Handles the SendMail cmd
 * 
 * @author adrien
 * 
 */
public class SendMailHandler extends MailRequestHandler {

	public SendMailHandler(IBackend backend) {
		super(backend);
	}

	@Override
	public void process(IContinuation continuation, BackendSession bs,
			InputStream mailContent, Boolean saveInSent, ActiveSyncRequest request,
			Responder responder) throws SendEmailException, ProcessingEmailException, SmtpInvalidRcptException {
		logger.info("process(" + bs.getLoginAtDomain() + "/" + bs.getDevType()
				+ ")");
		backend.getContentsImporter(null, bs).sendEmail(bs, mailContent, saveInSent);
	}

}
