package org.obm.push.impl;

import java.io.InputStream;

import org.obm.push.backend.BackendSession;
import org.obm.push.backend.IBackend;
import org.obm.push.backend.IContinuation;
import org.obm.push.exception.ProcessingEmailException;
import org.obm.push.exception.SendEmailException;
import org.obm.push.exception.SmtpInvalidRcptException;

/**
 * Handles the SmartReply cmd
 * 
 * @author adrien
 * 
 */
public class SmartForwardHandler extends MailRequestHandler {

	public SmartForwardHandler(IBackend backend) {
		super(backend);
	}

	@Override
	public void process(IContinuation continuation, BackendSession bs,
			InputStream mailContent, Boolean saveInSent, ActiveSyncRequest request,
			Responder responder)  throws SendEmailException, ProcessingEmailException, SmtpInvalidRcptException {
		logger.info("process(" + bs.getLoginAtDomain() + "/" + bs.getDevType()
				+ ")");

		String collectionId = request.getParameter("CollectionId");
		String serverId = request.getParameter("ItemId");

		backend.getContentsImporter(null, bs).forwardEmail(bs, mailContent,
				saveInSent, collectionId, serverId);
	}
}
